# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/02_skip.ipynb.

# %% auto 0
__all__ = ['SkipMagic']

# %% ../nbs/02_skip.ipynb 4
from IPython.core.magic import magics_class, line_cell_magic, Magics
from ipywidgets import get_ipython

# %% ../nbs/02_skip.ipynb 5
from nlit import CELL, LINE
from .base import BaseMagic

# %% ../nbs/02_skip.ipynb 7
@magics_class
class SkipMagic(BaseMagic):
    '''
    A class that provides a magic to skip the execution of a cell based on a boolean value.
    '''
    @line_cell_magic
    def skip(self, line, cell=None):
        '''
        Skips execution of the current line/cell if line evaluates to True.
        
        Parameters
        ----------
        line : str
            The line to evaluate for skipping.
        cell : str, optional
            The cell contents to execute if line evaluates to False.
            
        Returns
        -------
        None
        '''
        if eval(line, self.shell.user_ns):
            return

        if cell:  # Only execute if there's cell content to execute
            get_ipython().ex(cell)

